// =====================================================================
//  resize_host.c
// =====================================================================

//  Author:         (c) 2013 Camil Demetrescu
//  License:        See the end of this file for license information
//  Created:        July 11, 2013
 
//  Last changed:   $Date: 2013/07/11 9:00:17 $
//  Changed by:     $Author: demetres $
//  Revision:       $Revision: 1.00 $


#include "resize.h"


// ---------------------------------------------------------------------
// resize_host
// ---------------------------------------------------------------------
// sequential CPU version executed on host

void resize_host(unsigned char* in, unsigned char* out, 
                 int w, int h, double* t) {

    // get initial time
    double start = clut_get_real_time();

    int x, y;

    for (y=0; y<h/2; y++)
        for (x=0; x<w/2; x++)
            out[y*(w/2)+x] = (in[2*y*w+2*x]+in[2*y*w+2*x+1]+
                              in[(2*y+1)*w+2*x]+in[(2*y+1)*w+2*x+1])/4;
    
    // get elapsed time
    *t = clut_get_real_time() - start;
}


// Copyright (C) 2013 Camil Demetrescu
  
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
  
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
  
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
// USA
